import pygame
import random

class Road:
    def __init__(self, x, y, width, height):
        self.rect = pygame.Rect(x, y, width, height)

# Horizontal Road class
class HRoad(Road):
    def __init__(self, y,width, height):
        super().__init__(0, y, width, height)

# Vertical Road class
class VRoad(Road):
    def __init__(self, x, width, height):
        super().__init__(x, 0, width, height)

def generate_roads(num_vertical_roads, num_horizontal_roads, mapwidth, mapheight):
    roads = []

    x = 10
    # 生成垂直道路
    for i in range(num_vertical_roads):
        x = x + 1400 / num_vertical_roads
        width = 20
        roads.append(VRoad(x, width, mapheight))

    # 生成水平道路
    y = 10
    for i in range(num_horizontal_roads):   
        y = y + 1000 / num_horizontal_roads
        height = 20
        roads.append(HRoad(y, mapwidth, height))
    return roads

def generate_cam_pos(num_vertical_roads, num_horizontal_roads, mapwidth, mapheight):
    cam_list = []
    x = 0
    # 生成垂直道路
    for i in range(num_vertical_roads):
        x = x + mapwidth / num_vertical_roads
        # 生成水平道路
        y = 0
        for i in range(num_horizontal_roads):   
            y = y + mapheight / num_horizontal_roads + 15
            cam_list.append([x,y])
    return cam_list